import { DelegateEventHandler } from 'web-utility';
import { IReactionPublic } from 'mobx';
import { FunctionComponent } from './utility/vDOM';
import { WebCellComponent, WebCellClass, ComponentClass } from './WebCell';
export interface ComponentMeta extends Partial<ShadowRootInit> {
    tagName: `${string}-${string}`;
    extends?: keyof HTMLElementTagNameMap;
}
export declare function component(meta: ComponentMeta): <T extends WebCellClass<import("./utility/vDOM").WebCellProps<HTMLElement>>>(Class: T) => T;
export declare function observer<T extends FunctionComponent | ComponentClass>(Component: T): any;
export declare function attribute<T extends InstanceType<WebCellClass>>({ constructor }: T, key: string): void;
declare type ReactionHandler<I = any, O = any> = (data?: I, reaction?: IReactionPublic) => O;
export interface ReactionDelegater {
    methodKey: string;
    expression: ReactionHandler;
}
export declare function reaction<C extends WebCellComponent, V>(expression: ReactionHandler<C, V>): ({ constructor }: C, key: string, meta: TypedPropertyDescriptor<ReactionHandler<V>>) => TypedPropertyDescriptor<ReactionHandler<V, any>>;
export interface DOMEventDelegater {
    type: keyof HTMLElementEventMap;
    selector: string;
    method: string;
}
export declare function on(type: DOMEventDelegater['type'], selector: string): <T extends DelegateEventHandler<any>, I extends WebCellComponent<import("./utility/vDOM").WebCellProps<HTMLElement>>>({ constructor }: I, method: string, meta: PropertyDescriptor) => PropertyDescriptor & {
    value: T;
};
export {};
